]> git.sesse.net Git - ffmpeg/blobdiff - configure
3 lines while -> 1 line for loop
[ffmpeg] / configure
index 9c8481518245784731e4089e250f8e758c1b22fc..db94c14dd4684141ae97ca9232d3410a3a866eef 100755 (executable)
--- a/configure
+++ b/configure
@@ -9,6 +9,7 @@ show_help(){
   echo
   echo "Standard options:"
   echo "  --help                   print this message"
+  echo "  --log[=FILE|yes|no]      log tests and output to FILE [config.err]"
   echo "  --prefix=PREFIX          install in PREFIX [$prefix]"
   echo "  --libdir=DIR             install libs in DIR [PREFIX/lib]"
   echo "  --incdir=DIR             install includes in DIR [PREFIX/include/ffmpeg]"
@@ -47,6 +48,7 @@ show_help(){
   echo "Advanced options (experts only):"
   echo "  --source-path=PATH       path to source code [$source_path]"
   echo "  --cross-prefix=PREFIX    use PREFIX for compilation tools [$cross_prefix]"
+  echo "  --cross-compile          assume a cross-compiler is used"
   echo "  --cc=CC                  use C compiler CC [$cc]"
   echo "  --make=MAKE              use specified make [$make]"
   echo "  --extra-cflags=ECFLAGS   add ECFLAGS to CFLAGS [$CFLAGS]"
@@ -96,8 +98,53 @@ show_help(){
   exit 1
 }
 
+log(){
+    echo "$@" >>$logfile
+}
+
+logfile(){
+    log BEGIN $1
+    cat -n $1 >>$logfile
+    log END $1
+}
+
+echolog(){
+    log "$@"
+    echo "$@"
+}
+
+die(){
+    echolog "$@"
+    cat <<EOF
+If you think configure made a mistake, make sure you are using the latest
+version from SVN.  If the latest version fails, report the problem to the
+ffmpeg-devel@mplayerhq.hu mailing list or IRC #ffmpeg on irc.freenode.net.
+EOF
+    if enabled log; then
+        cat <<EOF
+Include the log file "$logfile" produced by configure as this will help
+solving the problem.
+EOF
+    else
+cat <<EOF
+Rerun configure with logging enabled (do not use --log=no), and include the
+log this produces with your report.
+EOF
+    fi
+    rm -f $TMPC $TMPO $TMPE $TMPS $TMPH
+    exit 1
+}
+
+enabled(){
+    eval test "\$$1" = "yes"
+}
+
+flags_saved(){
+    (: ${SAVE_CFLAGS?}) 2>/dev/null
+}
+
 save_flags(){
-    (:${SAVE_CFLAGS?}) 2>/dev/null && return
+    flags_saved && return
     SAVE_CFLAGS="$CFLAGS"
     SAVE_LDFLAGS="$LDFLAGS"
     SAVE_extralibs="$extralibs"
@@ -127,38 +174,77 @@ temp_extralibs(){
     extralibs="$extralibs $*"
 }
 
+append(){
+    var=$1
+    shift
+    flags_saved && eval "SAVE_$var=\"\$SAVE_$var $*\""
+    eval "$var=\"\$$var $*\""
+}
+
+add_cflags(){
+    append CFLAGS "$@"
+}
+
+add_ldflags(){
+    append LDFLAGS "$@"
+}
+
+add_extralibs(){
+    append extralibs "$@"
+}
+
 check_cc(){
+    log check_cc "$@"
     cat >$TMPC
-    ${cross_prefix}$cc $CFLAGS "$@" -c -o $TMPO $TMPC >/dev/null 2>&1
+    logfile $TMPC
+    log $cc $CFLAGS "$@" -c -o $TMPO $TMPC
+    $cc $CFLAGS "$@" -c -o $TMPO $TMPC >>$logfile 2>&1
+}
+
+check_cpp(){
+    log check_cpp "$@"
+    cat >$TMPC
+    logfile $TMPC
+    log $cc $CFLAGS "$@" -E -o $TMPO $TMPC
+    $cc $CFLAGS "$@" -E -o $TMPO $TMPC >>$logfile 2>&1
 }
 
 check_ld(){
+    log check_ld "$@"
     cat >$TMPC
-    ${cross_prefix}$cc $CFLAGS $LDFLAGS "$@" -o $TMPE $TMPC $extralibs >/dev/null 2>&1
+    logfile $TMPC
+    log $cc $CFLAGS $LDFLAGS "$@" -o $TMPE $TMPC $extralibs
+    $cc $CFLAGS $LDFLAGS "$@" -o $TMPE $TMPC $extralibs >>$logfile 2>&1
 }
 
 check_cflags(){
-    check_cc "$@" <<EOF && CFLAGS="$CFLAGS $*"
+    log check_cflags "$@"
+    check_cc "$@" <<EOF && add_cflags "$@"
 int x;
 EOF
 }
 
 check_ldflags(){
-    check_ld "$@" <<EOF && LDFLAGS="$LDFLAGS $*"
-int x;
+    log check_ldflags "$@"
+    check_ld "$@" <<EOF && add_ldflags "$@"
+int main(){
+    return 0;
+}
 EOF
 }
 
 check_header(){
+    log check_header "$@"
     header=$1
     shift
-    check_cc "$@" <<EOF
+    check_cpp "$@" <<EOF
 #include <$header>
 int x;
 EOF
 }
 
 check_func(){
+    log check_func "$@"
     func=$1
     shift
     check_ld "$@" <<EOF
@@ -169,8 +255,28 @@ int main(){
 EOF
 }
 
+check_lib(){
+    log check_lib "$@"
+    header="$1"
+    func="$2"
+    shift 2
+    temp_extralibs "$@"
+    check_header $header && check_func $func && add_extralibs "$@"
+    err=$?
+    restore_flags
+    return $err
+}
+
 check_exec(){
-    check_ld "$@" && (test -z "$cross_prefix" && $TMPE || true)
+    check_ld "$@" && { test "$cross_compile" = yes || $TMPE 2>&1 >>$logfile; }
+}
+
+require(){
+    name="$1"
+    header="$2"
+    func="$3"
+    shift 3
+    check_lib $header $func "$@" || die "ERROR: $name not found"
 }
 
 if test x"$1" = x"-h" -o x"$1" = x"--help" ; then
@@ -193,12 +299,15 @@ TMPS="${TMPDIR1}/ffmpeg-conf-${RANDOM}-$$-${RANDOM}.S"
 TMPH="${TMPDIR1}/ffmpeg-conf-${RANDOM}-$$-${RANDOM}.h"
 
 # default parameters
+log="yes"
+logfile="config.err"
 prefix="/usr/local"
 libdir=""
 incdir=""
 mandir=""
 bindir=""
 cross_prefix=""
+cross_compile="no"
 cc="gcc"
 ar="ar"
 ranlib="ranlib"
@@ -234,7 +343,7 @@ case "$cpu" in
   "Power Macintosh"|ppc|powerpc)
     cpu="powerpc"
   ;;
-  mips|mipsel)
+  mips|mipsel|IP*)
     cpu="mips"
   ;;
   sun4u|sparc64)
@@ -389,7 +498,6 @@ bktr="yes"
 audio_oss="yes"
 dv1394="no"
 make="gmake"
-FFLDFLAGS="$FFLDFLAGS -export-dynamic"
 extralibs="$extralibs -lossaudio"
 ;;
 OpenBSD)
@@ -400,7 +508,6 @@ audio_oss="yes"
 dv1394="no"
 make="gmake"
 LIBOBJFLAGS="\$(PIC)"
-FFLDFLAGS="$FFLDFLAGS -export-dynamic -pthread"
 LDCONFIG="ldconfig -m \$(libdir)"
 extralibs="$extralibs -lossaudio"
 ;;
@@ -412,7 +519,14 @@ audio_oss="yes"
 dv1394="no"
 make="gmake"
 CFLAGS="$CFLAGS -pthread"
-FFLDFLAGS="$FFLDFLAGS -export-dynamic -pthread"
+;;
+GNU/kFreeBSD)
+v4l="no"
+v4l2="no"
+bktr="yes"
+audio_oss="yes"
+dv1394="no"
+CFLAGS="$CFLAGS -pthread"
 ;;
 BSD/OS)
 v4l="no"
@@ -458,7 +572,6 @@ cygwin="yes"
 EXESUF=".exe"
 ;;
 Linux)
-FFLDFLAGS="$FFLDFLAGS -rdynamic -Wl,--as-needed -Wl,-rpath-link,\$(BUILD_ROOT)/libavcodec -Wl,-rpath-link,\$(BUILD_ROOT)/libavformat -Wl,-rpath-link,\$(BUILD_ROOT)/libavutil"
 ;;
 IRIX*)
 ranlib="echo ignoring ranlib"
@@ -535,6 +648,10 @@ CODEC_LIST=`grep 'register_avcodec(&[a-z]' $source_path/libavcodec/allcodecs.c
 
 for opt do
   case "$opt" in
+  --log)
+  ;;
+  --log=*) log="${opt#*=}"
+  ;;
   --prefix=*) prefix=`echo $opt | cut -d '=' -f 2`; force_prefix=yes
   ;;
   --libdir=*) libdir=`echo $opt | cut -d '=' -f 2`; force_libdir=yes
@@ -547,6 +664,8 @@ for opt do
   ;;
   --cross-prefix=*) cross_prefix=`echo $opt | cut -d '=' -f 2`
   ;;
+  --cross-compile) cross_compile=yes
+  ;;
   --cc=*) cc=`echo $opt | cut -d '=' -f 2-`
   ;;
   --make=*) make=`echo $opt | cut -d '=' -f 2`
@@ -596,44 +715,33 @@ for opt do
   --enable-a52bin) a52bin="yes"
   ;;
   --enable-dts) dts="yes"
-    extralibs="$extralibs -ldts"
   ;;
   --enable-pp) pp="yes"
   ;;
   --enable-libgsm) libgsm="yes"
-    extralibs="$extralibs -lgsm"
   ;;
   --enable-mp3lame) mp3lame="yes"
-    extralibs="$extralibs -lmp3lame"
   ;;
   --enable-libogg) libogg="yes"
-    extralibs="$extralibs -logg"
     pkg_requires="$pkg_requires ogg >= 1.1"
   ;;
   --enable-vorbis) vorbis="yes"
-    extralibs="$extralibs -lvorbis -lvorbisenc"
     pkg_requires="$pkg_requires vorbis vorbisenc"
   ;;
   --enable-theora) theora="yes"
-    extralibs="$extralibs -ltheora"
     pkg_requires="$pkg_requires theora"
   ;;
   --enable-faad) faad="yes"
-    extralibs="$extralibs -lfaad"
   ;;
   --enable-faadbin) faadbin="yes"
   ;;
   --enable-faac) faac="yes"
-    extralibs="$extralibs -lfaac"
   ;;
   --enable-xvid) xvid="yes"
-    extralibs="$extralibs -lxvidcore"
   ;;
   --enable-x264) x264="yes"
-    extralibs="$extralibs -lx264"
   ;;
   --enable-dc1394) dc1394="yes"
-    extralibs="$extralibs -ldc1394_control -lraw1394"
     pkg_requires="$pkg_requires libraw1394"
   ;;
   --disable-vhook) vhook="no"
@@ -710,10 +818,23 @@ for opt do
   esac
 done
 
+if test "$log" != no; then
+    test "$log" = yes || logfile="$log"
+    echo "# $0 $@" >$logfile
+    set >>$logfile
+else
+    logfile=/dev/null
+fi
 
 # Combine FFLDFLAGS and the LDFLAGS environment variable
 LDFLAGS="$FFLDFLAGS $LDFLAGS"
 
+test -n "$cross_prefix" && cross_compile=yes
+cc="${cross_prefix}${cc}"
+ar="${cross_prefix}${ar}"
+ranlib="${cross_prefix}${ranlib}"
+strip="${cross_prefix}${strip}"
+
 # we need to build at least one lib type
 if test "$lstatic" = "no" && test "$lshared" = "no" ; then
     cat <<EOF
@@ -912,6 +1033,22 @@ if test $tune != "generic"; then
     esac
 fi
 
+# compiler sanity check
+check_exec <<EOF
+int main(){
+    return 0;
+}
+EOF
+if test "$?" != 0; then
+    echo "$cc is unable to create an executable file."
+    if test -z "$cross_prefix" -a "$cross_compile" = no; then
+        echo "If $cc is a cross-compiler, use the --cross-compile option."
+    fi
+    die "C compiler test failed."
+fi
+
+# check for SIMD availability
+
 # AltiVec flags: The FSF version of GCC differs from the Apple version
 if test $cpu = "powerpc"; then
     if test $altivec = "yes"; then
@@ -927,12 +1064,12 @@ check_header altivec.h && _altivec_h=yes || _altivec_h=no
 
 # check if our compiler supports Motorola AltiVec C API
 if test $altivec = "yes"; then
-if test $_altivec_h = "yes"; then
-    inc_altivec_h="#include <altivec.h>"
-else
-    inc_altivec_h=
-fi
-check_cc <<EOF || altivec=no
+    if test $_altivec_h = "yes"; then
+        inc_altivec_h="#include <altivec.h>"
+    else
+        inc_altivec_h=
+    fi
+    check_cc <<EOF || altivec=no
 $inc_altivec_h
 int main(void) {
     vector signed int v1, v2, v3;
@@ -952,14 +1089,37 @@ if test $mmi = "default"; then
 fi
 
 # check if our compiler supports mmi
-if test $mmi = "yes"; then
-check_cc <<EOF || mmi="no"
+enabled mmi && check_cc <<EOF || mmi="no"
 int main(void) {
     __asm__ ("lq \$2, 0(\$2)");
     return 0;
 }
 EOF
-fi
+
+# test gcc version to see if vector builtins can be used
+# currently only used on i386 for MMX builtins
+check_cc -msse <<EOF && builtin_vector=yes || builtin_vector=no
+#include <xmmintrin.h>
+int main(void) {
+#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
+return 0;
+#else
+#error no vector builtins
+#endif
+}
+EOF
+
+# test for mm3dnow.h
+test "$cpu" = "x86_64" && march=k8 || march=athlon
+check_cc -march=$march <<EOF && mm3dnow=yes || mm3dnow=no
+#include <mm3dnow.h>
+int main(void) {
+__m64 b1;
+b1 = _m_pswapd(b1);
+_m_femms();
+return 0;
+}
+EOF
 
 if test "$mingw32" = "yes" -o "$mingwce" = "yes"; then
     if test "$lshared" = "yes" && test "$lstatic" = "yes" ; then
@@ -979,46 +1139,31 @@ EOF
     dc1394="no"
     ffserver="no"
     network="no"
-if test "$mingwce" = "yes"; then
-    protocols="no"
-fi
+    if test "$mingwce" = "yes"; then
+        protocols="no"
+    fi
     SLIBPREF=""
     SLIBSUF=".dll"
     EXESUF=".exe"
-    if test "$force_prefix" != yes; then prefix="/c/Program Files/FFmpeg"; fi
+    if test "$force_prefix" != yes; then prefix="$PROGRAMFILES/FFmpeg"; fi
     if test "$force_libdir" != yes; then bindir="$prefix"; fi
 fi
 
-cc="${cross_prefix}${cc}"
-ar="${cross_prefix}${ar}"
-ranlib="${cross_prefix}${ranlib}"
-strip="${cross_prefix}${strip}"
-
-if test -z "$cross_prefix" ; then
-
 # ---
 # big/little-endian test
-check_ld <<EOF
+if test "$cross_compile" = "no"; then
+    check_ld <<EOF || die "endian test failed" && $TMPE && bigendian="yes"
 #include <inttypes.h>
 int main(int argc, char ** argv){
         volatile uint32_t i=0x01234567;
         return (*((uint8_t*)(&i))) == 0x67;
 }
 EOF
-
-if test $? = 0 ; then
-    $TMPE && bigendian="yes"
 else
-    echo big/little test failed
-fi
-
-else
-
-# programs cannot be launched if cross compiling, so make a static guess
-if test "$cpu" = "powerpc" -o "$cpu" = "mips" ; then
-    bigendian="yes"
-fi
-
+    # programs cannot be launched if cross compiling, so make a static guess
+    if test "$cpu" = "powerpc" -o "$cpu" = "mips" ; then
+        bigendian="yes"
+    fi
 fi
 
 # ---
@@ -1047,31 +1192,65 @@ if check_header malloc.h; then
 fi
 
 if test "$_memalign" = "no" -a "$mmx" = "yes" -a "$memalignhack" != "yes"; then
-    echo "Error, no memalign() but SSE enabled, disable it or use --enable-memalign-hack."
-    exit 1
+    die "Error, no memalign() but SSE enabled, disable it or use --enable-memalign-hack."
 fi
 
 check_func localtime_r && localtime_r=yes || localtime_r=no
-
-if test "$zlib" = "yes"; then
-    temp_extralibs -lz
-    check_header zlib.h && check_func zlibVersion || zlib="no"
-    # XXX: more tests needed - runtime test
+enabled zlib && check_lib zlib.h zlibVersion -lz || zlib="no"
+enabled lzo && enabled gpl && check_lib lzo1x.h lzo_version -llzo || lzo="no"
+
+# check for some common methods of building with pthread support
+# do this before the optional library checks as some of them require pthreads
+if enabled pthreads; then
+    { check_cflags -pthread && check_ldflags -pthread; } ||
+    { check_cflags -pthreads && check_ldflags -pthreads; } ||
+    check_lib pthread.h pthread_create -lpthread ||
+    check_func pthread_create ||
+    die "ERROR: can't find pthreads library"
+fi
+
+# these are off by default, so fail if requested and not available
+enabled dts     && require libdts dts.h dts_init -ldts
+enabled libgsm  && require libgsm gsm.h gsm_create -lgsm
+enabled mp3lame && require LAME lame/lame.h lame_init -lmp3lame
+enabled vorbis  && require libvorbis vorbis/vorbisenc.h vorbis_info_init -lvorbis -lvorbisenc
+enabled libogg  && require libogg ogg/ogg.h ogg_sync_init -logg
+enabled theora  && require libtheora theora/theora.h theora_info_init -ltheora
+enabled xvid    && require XviD xvid.h xvid_global -lxvidcore
+enabled x264    && require x264 x264.h x264_encoder_open -lx264
+enabled dc1394  && require libdc1394 libdc1394/dc1394_control.h dc1394_create_handle -ldc1394_control -lraw1394
+enabled sunmlib && require mediaLib mlib_types.h mlib_VectorSub_S16_U8_Mod -lmlib
+
+# Ugh, faac uses stdcall calling convention on win32 so we can't use
+# the generic test functions
+if enabled faac; then
+    save_flags
+    temp_extralibs -lfaac
+    check_ld <<EOF && add_extralibs -lfaac || die "ERROR: libfaac not found"
+#include <stdint.h>
+#include <faac.h>
+int main(){
+    char *id, *cpr;
+    faacEncGetVersion(&id, &cpr);
+    return 0;
+}
+EOF
     restore_flags
 fi
-if test "$zlib" = "yes"; then
-    extralibs="$extralibs -lz"
-fi
 
-if test "$lzo" = "yes" -a "$gpl" = "yes"; then
-    temp_extralibs -llzo
-    check_header lzo1x.h && check_func lzo_version || lzo="no"
+# Ugh, recent faad2 versions have renamed all functions and #define the
+# old names in faad.h.  Generic tests won't work.
+if enabled faad; then
+    save_flags
+    temp_extralibs -lfaad
+    check_ld <<EOF && add_extralibs -lfaad || die "ERROR: libfaad not found"
+#include <faad.h>
+int main(){
+    faacDecOpen();
+    return 0;
+}
+EOF
     restore_flags
-else
-    lzo="no"
-fi
-if test "$lzo" = "yes"; then
-    extralibs="$extralibs -llzo"
 fi
 
 # test for lrintf in math.h
@@ -1083,42 +1262,11 @@ EOF
 
 _restrict=
 for restrict_keyword in restrict __restrict__ __restrict; do
-    check_cc <<EOF
+    check_cc <<EOF && _restrict=$restrict_keyword && break
 void foo(char * $restrict_keyword p);
 EOF
-    if test $? = 0; then
-        _restrict=$restrict_keyword
-        break;
-    fi
 done
 
-# test gcc version to see if vector builtins can be used
-# currently only used on i386 for MMX builtins
-check_cc -msse <<EOF && builtin_vector=yes || builtin_vector=no
-#include <xmmintrin.h>
-int main(void) {
-#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
-return 0;
-#else
-#error no vector builtins
-#endif
-}
-EOF
-
-# test for mm3dnow.h
-test "$cpu" = "x86_64" && march=k8 || march=athlon
-check_cc -march=$march <<EOF && mm3dnow=yes || mm3dnow=no
-#include <mm3dnow.h>
-int main(void) {
-__m64 b1;
-b1 = _m_pswapd(b1);
-_m_femms();
-return 0;
-}
-EOF
-
-check_cflags -Wdeclaration-after-statement
-
 # dlopen/dlfcn.h probing
 
 check_header dlfcn.h && dlfcn=yes
@@ -1135,14 +1283,18 @@ if check_func dlopen; then
     ldl=
 fi
 
-if test "$vhook" = "default" ; then
-  vhook="$dlopen"
+if test "$vhook" = "default"; then
+    vhook="$dlopen"
 fi
 
 if test "$vhook" = "yes" -o "$a52bin" = "yes" -o "$faadbin" = "yes"; then
-  extralibs="$extralibs $ldl"
+    add_extralibs $ldl
 fi
 
+if enabled vhook; then
+    check_ldflags -rdynamic
+    check_ldflags -export-dynamic
+fi
 
 ##########################################
 # imlib check
@@ -1185,17 +1337,27 @@ if ("${SDL_CONFIG}" --version) >/dev/null 2>&1 ; then
 #undef main /* We don't want SDL to override our main() */
 int main( void ) { return SDL_Init (SDL_INIT_VIDEO); }
 EOF
-    restore_flags
     if test $? = 0; then
         _sdlversion=`"${SDL_CONFIG}" --version | sed 's/[^0-9]//g'`
         if test "$_sdlversion" -lt 121 ; then
             sdl_too_old=yes
         else
             sdl=yes
+            check_cc <<EOF && sdl_video_size=yes || sdl_video_size=no
+#include <SDL.h>
+int main(void){
+    const SDL_VideoInfo *vi = SDL_GetVideoInfo();
+    int w = vi->current_w;
+    return 0;
+}
+EOF
         fi
     fi
+    restore_flags
 fi
 
+enabled sdl || ffplay=no
+
 ##########################################
 # texi2html check
 
@@ -1207,7 +1369,7 @@ fi
 ##########################################
 # IPv6 check
 
-test "$network" = "yes" && check_ld <<EOF && ipv6=yes || ipv6=no
+enabled network && check_ld <<EOF && ipv6=yes || ipv6=no
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
@@ -1222,7 +1384,7 @@ int main( void ) {
 EOF
 
 # check for video4linux2 --- V4L2_PIX_FMT_YUV420
-test "$v4l2" = "yes" && check_cc <<EOF || v4l2="no"
+enabled v4l2 && check_cc <<EOF || v4l2="no"
 #include <sys/time.h>
 #include <asm/types.h>
 #include <linux/videodev2.h>
@@ -1230,23 +1392,20 @@ int dummy = V4L2_PIX_FMT_YUV420;
 struct v4l2_buffer dummy1;
 EOF
 
+enabled debug && add_cflags -g
+
+# add some useful compiler flags if supported
+check_cflags -Wdeclaration-after-statement
 check_cflags -Wall
 check_cflags -Wno-switch
 
-if test "$sdl" = "no" ; then
-   ffplay=no
-fi
-
-if test "$debug" = "yes"; then
-    CFLAGS="-g $CFLAGS"
-fi
+# add some linker flags
+check_ldflags '-Wl,--as-needed' '-Wl,-rpath-link,\$(BUILD_ROOT)/libavcodec' '-Wl,-rpath-link,\$(BUILD_ROOT)/libavformat' '-Wl,-rpath-link,\$(BUILD_ROOT)/libavutil'
 
-if test "$optimize" = "small"; then
-#  CFLAGS=${CFLAGS//-O3/-Os}
-    CFLAGS="$CFLAGS -Os"
-fi
+# not all compilers support -Os
+test "$optimize" = "small" && check_cflags -Os
 
-if test "$optimize" = "yes"; then
+if enabled optimize; then
     if test -n "`$cc -v 2>&1 | grep xlc`"; then
         CFLAGS="$CFLAGS -O5"
         LDFLAGS="$LDFLAGS -O5"
@@ -1257,28 +1416,28 @@ fi
 
 # PIC flags for shared library objects where they are needed
 if test "$lshared" = "yes" ; then
-  # LIBOBJFLAGS may have already been set in the OS configuration
-  if test -z "$LIBOBJFLAGS" ; then
-    if test "$cpu" = "x86_64" -o "$cpu" = "ia64" -o "$cpu" = "alpha" ; then
-      LIBOBJFLAGS="\$(PIC)"
+    # LIBOBJFLAGS may have already been set in the OS configuration
+    if test -z "$LIBOBJFLAGS" ; then
+        if test "$cpu" = "x86_64" -o "$cpu" = "ia64" -o "$cpu" = "alpha" ; then
+            LIBOBJFLAGS="\$(PIC)"
+        fi
     fi
-  fi
 fi
 
 if test x"$bindir" = x""; then
-bindir="${prefix}/bin"
+    bindir="${prefix}/bin"
 fi
 
 if test x"$libdir" = x""; then
-libdir="${prefix}/lib"
+    libdir="${prefix}/lib"
 fi
 
 if test x"$incdir" = x""; then
-incdir="${prefix}/include/ffmpeg"
+    incdir="${prefix}/include/ffmpeg"
 fi
 
 if test x"$mandir" = x""; then
-mandir="${prefix}/man"
+    mandir="${prefix}/man"
 fi
 
 echo "install prefix   $prefix"
@@ -1287,24 +1446,24 @@ echo "C compiler       $cc"
 echo "make             $make"
 echo "CPU              $cpu ($tune)"
 if test "$BUILDSUF" != ""; then
-echo "build suffix     $BUILDSUF"
+    echo "build suffix     $BUILDSUF"
 fi
 echo "big-endian       $bigendian"
 echo "inttypes.h       $inttypes"
 echo "broken inttypes.h $emu_fast_int"
 if test $cpu = "x86" -o $cpu = "x86_64"; then
-echo "MMX enabled      $mmx"
-echo "Vector Builtins  $builtin_vector"
-echo "3DNow! Builtins  $mm3dnow"
+    echo "MMX enabled      $mmx"
+    echo "Vector Builtins  $builtin_vector"
+    echo "3DNow! Builtins  $mm3dnow"
 fi
 if test $cpu = "armv4l"; then
-echo "IWMMXT enabled   $iwmmxt"
+    echo "IWMMXT enabled   $iwmmxt"
 fi
 if test $cpu = "mips"; then
-echo "MMI enabled      $mmi"
+    echo "MMI enabled      $mmi"
 fi
 if test $cpu = "powerpc"; then
-echo "AltiVec enabled  $altivec"
+    echo "AltiVec enabled  $altivec"
 fi
 echo "gprof enabled    $gprof"
 echo "zlib enabled     $zlib"
@@ -1331,12 +1490,12 @@ echo "shared           $lshared"
 echo "video hooking    $vhook"
 echo "SDL support      $sdl"
 if test $sdl_too_old = "yes"; then
-echo "-> Your SDL version is too old - please upgrade to have FFplay/SDL support."
+    echo "-> Your SDL version is too old - please upgrade to have FFplay/SDL support."
 fi
 
-if test "$vhook" = "yes" ; then
-echo "Imlib2 support   $imlib2"
-echo "FreeType support $freetype2"
+if test "$vhook" = "yes"; then
+    echo "Imlib2 support   $imlib2"
+    echo "FreeType support $freetype2"
 fi
 echo "Sun medialib support"  $sunmlib
 echo "pthreads support"      $pthreads
@@ -1346,12 +1505,12 @@ echo "AMR-WB float support"  $amr_wb
 echo "AMR-WB IF2 support"    $amr_if2
 echo "network support      $network"
 if test "$network" = "yes" ; then
-echo "IPv6 support         $ipv6"
+    echo "IPv6 support         $ipv6"
 fi
 if test "$gpl" = "no" ; then
-echo "License: LGPL"
+    echo "License: LGPL"
 else
-echo "License: GPL"
+    echo "License: GPL"
 fi
 
 echo "Creating config.mak and config.h..."
@@ -1372,19 +1531,17 @@ echo "CC=$cc" >> config.mak
 echo "AR=$ar" >> config.mak
 echo "RANLIB=$ranlib" >> config.mak
 if test "$dostrip" = "yes" ; then
-echo "STRIP=$strip" >> config.mak
-echo "INSTALLSTRIP=$installstrip" >> config.mak
+    echo "STRIP=$strip" >> config.mak
+    echo "INSTALLSTRIP=$installstrip" >> config.mak
 else
-echo "STRIP=echo ignoring strip" >> config.mak
-echo "INSTALLSTRIP=" >> config.mak
+    echo "STRIP=echo ignoring strip" >> config.mak
+    echo "INSTALLSTRIP=" >> config.mak
 fi
 
 # SHCFLAGS is a copy of CFLAGS without -mdynamic-no-pic, used when building
 # shared modules on OS/X (vhook/Makefile).
-SHCFLAGS=$CFLAGS
-if test "$needmdynamicnopic" = yes; then
-   CFLAGS="$CFLAGS -mdynamic-no-pic"
-fi
+SHCFLAGS="$CFLAGS"
+test "$needmdynamicnopic" = yes && add_cflags -mdynamic-no-pic
 
 echo "OPTFLAGS=$CFLAGS" >> config.mak
 echo "SHCFLAGS=$SHCFLAGS">>config.mak
@@ -1515,20 +1672,19 @@ fi
 if test "$sunmlib" = "yes" ; then
   echo "HAVE_MLIB=yes" >> config.mak
   echo "#define HAVE_MLIB 1" >> $TMPH
-  extralibs="$extralibs -lmlib"
 fi
 if test "$pthreads" = "yes" ; then
   echo "HAVE_PTHREADS=yes" >> config.mak
   echo "#define HAVE_PTHREADS 1" >> $TMPH
   echo "#define HAVE_THREADS 1" >> $TMPH
-  if test $targetos != FreeBSD -a $targetos != OpenBSD ; then
-     extralibs="$extralibs -lpthread"
-  fi
 fi
 if test "$sdl" = "yes" ; then
   echo "CONFIG_SDL=yes" >> config.mak
   echo "SDL_LIBS=`"${SDL_CONFIG}" --libs`" >> config.mak
   echo "SDL_CFLAGS=`"${SDL_CONFIG}" --cflags`" >> config.mak
+  if test "$sdl_video_size" = "yes"; then
+    echo "#define HAVE_SDL_VIDEO_SIZE 1" >> $TMPH
+  fi
 fi
 if test "$texi2html" = "yes"; then
   echo "BUILD_DOC=yes" >> config.mak
@@ -1541,7 +1697,7 @@ if test "$vhook" = "yes" ; then
   echo "#define HAVE_VHOOK 1" >> $TMPH
 fi
 
-pp_version=`grep '#define LIBPOSTPROC_VERSION ' "$source_path/libavcodec/libpostproc/postprocess.h" | sed 's/[^0-9\.]//g'`
+pp_version=`grep '#define LIBPOSTPROC_VERSION ' "$source_path/libpostproc/postprocess.h" | sed 's/[^0-9\.]//g'`
 lavc_version=`grep '#define LIBAVCODEC_VERSION ' "$source_path/libavcodec/avcodec.h" | sed 's/[^0-9\.]//g'`
 lavf_version=`grep '#define LIBAVFORMAT_VERSION ' "$source_path/libavformat/avformat.h" | sed 's/[^0-9\.]//g'`
 lavu_version=`grep '#define LIBAVUTIL_VERSION ' "$source_path/libavutil/avutil.h" | sed 's/[^0-9\.]//g'`
@@ -1565,9 +1721,7 @@ if test "$lshared" = "yes" ; then
   echo "SLIBNAME_WITH_MAJOR=${SLIBNAME_WITH_MAJOR}" >> config.mak
 fi
 echo "EXTRALIBS=$extralibs" >> config.mak
-version=`grep '#define FFMPEG_VERSION ' "$source_path/libavcodec/avcodec.h" |
- cut -d '"' -f 2`
-echo "VERSION=$version" >>config.mak
+
 # If you do not want to use encoders, disable them.
 echo "#define CONFIG_ENCODERS 1" >> $TMPH
 echo "CONFIG_ENCODERS=yes" >> config.mak
@@ -1840,7 +1994,7 @@ if test "$source_path_used" = "yes" ; then
          libavcodec/mlib \
          libavcodec/ppc \
          libavcodec/liba52 \
-         libavcodec/libpostproc \
+         libpostproc \
          libavutil \
          tests \
          vhook \
@@ -1849,7 +2003,7 @@ if test "$source_path_used" = "yes" ; then
           Makefile \
           libavformat/Makefile \
           libavcodec/Makefile \
-          libavcodec/libpostproc/Makefile \
+          libpostproc/Makefile \
           libavutil/Makefile \
           tests/Makefile \
           vhook/Makefile \
@@ -2039,8 +2193,8 @@ EOF
 cat <<EOF >libpostproc-uninstalled.pc
 prefix=
 exec_prefix=
-libdir=\${pcfiledir}/libavcodec/libpostproc
-includedir=\${pcfiledir}/libavcodec/libpostproc
+libdir=\${pcfiledir}/libpostproc
+includedir=\${pcfiledir}/libpostproc
 
 Name: libpostproc
 Description: FFmpeg post processing library